import java.awt.*;
import java.applet.Applet;

class ImageButton extends Canvas {

 Image image, img1, img2;
 int w, h, state;
 Color c;
 Container parent;

 public ImageButton(Image image1, Image image2, Container parent) {   

  Color c = new Color (191, 191, 191);
  this.parent = parent;
  img1 = image1;
  img2 = image2;
  image = image1;
  w = 127;
  h = 50;

 }

 public void update (Graphics g) {
  if (state == 2 || state == 3) 
   image = img2;
  else
   image = img1;
  paint (g);
 }

 public void paint (Graphics g) {

  g.drawImage(image, 0, 0, this);

  if (state == 1) {
   g.setColor (Color.lightGray);
   g.drawRect (0, 0, w - 1, h - 1);
  }

  if (state == 2) {
   g.setColor (Color.darkGray);
   g.drawLine(w - 1, 0, w - 1, h - 1);
   g.drawLine(w - 1, h - 1, 0 , h - 1);

   g.setColor (Color.white);
   g.drawLine(0, h - 1, 0, 0);
   g.drawLine(0, 0, w - 1 , 0);
  }

  if (state == 3) {
   g.setColor (Color.white);
   g.drawLine(w - 1, 0, w - 1, h - 1);
   g.drawLine(w - 1, h - 1, 0 , h - 1);

   g.setColor (Color.darkGray);
   g.drawLine(0, h - 1, 0, 0);
   g.drawLine(0, 0, w - 1 , 0);
  }

 }

 public boolean mouseEnter (Event evt, int x, int y) {

  state = 2;
  repaint ();
  return true;

 }

 public boolean mouseExit (Event evt, int x, int y) {

  state = 1;
  repaint ();
  return true;

 }

 public boolean mouseDown (Event evt, int x, int y) {

  if (state == 2) state = 3;
  repaint ();
  return true;

 }

 public boolean mouseUp (Event evt, int x, int y) {

  if (state == 3) {
   state = 2;
   if (! action( evt, evt.arg )) {
    Container parent1 = getParent();
    while (( parent1 != null ) &&
    (! parent.action( evt, evt.arg ))) {
     parent = parent.getParent();
    }
   }   
  }

  repaint ();
  return true;

 }

}
