import java.awt.*;
import java.io.*;
import java.net.*;

public class SQLclient extends java.applet.Applet {

 InputFrame inputframes, inputframec, inputframeq ;
 String sql, line;
 Socket s;
 DataInputStream dis;
 DataOutputStream dos;
 ImageButton button1, button2, button3;
 Image img1, img2, img3, img4, img5, img6;
 MediaTracker tracker;
 Color c;
 boolean inputs, inputc, inputq;
 int kl;

 public void init () {

  inputs = inputc = inputq = false;

  Color c = new Color (191, 191, 191);

  setBackground (c);

  img1 = getImage (getCodeBase (), "adds2.gif");
  img2 = getImage (getCodeBase (), "adds1.gif");
  img3 = getImage (getCodeBase (), "addc2.gif");
  img4 = getImage (getCodeBase (), "addc1.gif");
  img5 = getImage (getCodeBase (), "que2.gif");
  img6 = getImage (getCodeBase (), "que1.gif");
  
  tracker = new MediaTracker(this);
  tracker.addImage(img1,0);
  tracker.addImage(img2,1);
  tracker.addImage(img3,2);
  tracker.addImage(img4,3);
  tracker.addImage(img5,4);
  tracker.addImage(img6,5);

  for (int n = 0; n < 6; n++) {
    try {
     tracker.waitForID(n);
     kl = n + 1 ;
     getAppletContext ().showStatus ("Loading Images...Please wait..." + kl + "/6");
    }

    catch (InterruptedException e) {
    e.printStackTrace ();
    }
  }

  setLayout( new FlowLayout() );

  button1 = new ImageButton(img1, img2, this); 
  button2 = new ImageButton(img3, img4, this);
  button3 = new ImageButton(img5, img6, this);

  button1.resize (127, 50);
  button2.resize (127, 50);
  button3.resize (127, 50);

  add (button1);
  add (button2);
  add (button3);

  validate ();

  try {
   s = new Socket ("127.0.0.1", 9000);
   getAppletContext ().showStatus ("Contacting host 127.0.0.1...");
   dis = new DataInputStream (new BufferedInputStream(s.getInputStream ()));
   dos = new DataOutputStream (new BufferedOutputStream(s.getOutputStream ()));
  }

  catch (Exception e) {
   getAppletContext ().showStatus (e.toString ());
   return;
  }

  getAppletContext ().showStatus (" ");

 }

 public void stop (){

  if (inputs) {
   inputs = false;
   inputframes.hide ();
   inputframes.dispose ();
  }
  if (inputc) {
   inputc = false;
   inputframec.hide ();
   inputframec.dispose ();
  }
  if (inputq) {
   inputq = false;
   inputframeq.hide ();
   inputframeq.dispose ();
  }


 }

 public boolean action (Event evt, Object arg) {

  if (evt.target == button1) {

   if (inputc) {
    inputc = false;
    inputframec.hide ();
    inputframec.dispose ();
   }

   if (inputq) {
    inputq = false;
    inputframeq.hide ();
    inputframeq.dispose ();
   }

   if (!inputs) {
    inputframes = new InputFrame ("Add to Students table Form", this);
    inputframes.resize (500, 430);
    inputframes.show ();
    inputframes.resize (500, 430);
    inputframes.setResizable (false);
    inputs = true;
   }

   return true;

  }

  if (evt.target == button2) {

   if (inputs) {
    inputs = false;
    inputframes.hide ();
    inputframes.dispose ();
   }

   if (inputq) {
    inputq = false;
    inputframeq.hide ();
    inputframeq.dispose ();
   }

   if (!inputc) {
    inputframec = new InputFrame ("Add to Courses table Form", this, 1);
    inputframec.resize (500, 350);
    inputframec.show ();
    inputframec.resize (500, 350);
    inputframec.setResizable (false);
    inputc = true;
   }

   return true;

  }

  if (evt.target == button3) {

   if (inputc) {
    inputc = false;
    inputframec.hide ();
    inputframec.dispose ();
   }

   if (inputs) {
    inputs = false;
    inputframes.hide ();
    inputframes.dispose ();
   }

   if (!inputq) {
    inputframeq = new InputFrame ("Explore the Database", this, true);
    inputframeq.resize (650, 520);
    inputframeq.show ();
    inputframeq.resize (650, 520);
    inputframeq.setResizable (false);
    inputq = true;
   }

   return true;

  }

  return false;

 }

 public void send (String message) {

  try {
   dos.writeUTF (message);
   dos.flush ();
  }

  catch (IOException e) {
   getAppletContext ().showStatus (e.toString ()); 
  }

  String line = "";

  try {
   while
   (!line.endsWith ("Server message: end")) {

    line = dis.readUTF ();

    if (inputs == true) 
    inputframes.out.appendText (line + "\n");

    if (inputc == true)
    inputframec.out.appendText (line + "\n");

    if (inputq == true)
    inputframeq.out.appendText (line + "\n");

   }
  }

  catch (IOException e) {
   getAppletContext ().showStatus (e.toString ());
  }

 }

 public void constrain (Container container, Component component, int x,
 int y, int w, int h, int f, int anc, int t, int l, int b, int r) {

  GridBagConstraints c = new GridBagConstraints ();
  c.gridx = x;
  c.gridy = y;
  c.gridwidth = w;
  c.gridheight = h;
  c.fill = f;
  c.anchor = anc;
  c.insets = new Insets (t, l, b, r);
  ((GridBagLayout) container.getLayout ()).setConstraints (component, c);
  container.add (component);

 }

 public Choice makeChoice (String select) {

  Choice ch;
  ch = new Choice ();

  try {
   dos.writeUTF (select);
   dos.flush ();
  }

  catch (IOException e) {
   getAppletContext ().showStatus (e.toString ());
  }

  String line = "";

  try {

   while (!line.endsWith ("Server message: end")) {

    line = dis.readUTF ();

    if (!line.endsWith ("Server message: end"))
    ch.addItem (line);

   }

  }

  catch (IOException e) {
   getAppletContext ().showStatus (e.toString ());
  }

  return ch;

 }

}
